# Get VRP Payment Details
source: https://developer.mastercard.com/open-banking-connect/documentation/pisfeatures/get-vrp-payment-details-request/index.md

## Request overview {#request-overview}

The goal of this request is to get VRP payment details.

### Endpoint details {#endpoint-details}

|       **Endpoints/Resources**       | **Method** |                **API Profiles**                 |                                      **Description**                                       |
|-------------------------------------|------------|-------------------------------------------------|--------------------------------------------------------------------------------------------|
| /payments/domestic-vrps/vrp-details | `POST`     | CMA9 (restricted to specific ASPSPs and TPPs\*) | Retrieve VRP payment details (based on the previously obtained Payment ID) from the ASPSP. |

\*UK only. Available on subscription.

The following sequence diagram shows the flows for a Get VRP Payment Details request.
Diagram vrp_payment_details

## Request scenario {#request-scenario}


API Reference: `POST /payments/domestic-vrps/vrp-details`

#### Request header {#request-header}

|        **Name**        |              **Purpose**              | **Required by** |                        **How it can be used**                        | **Condition** | **Multiplicity** | **Type** |                                                                           **Description**                                                                           |
|------------------------|---------------------------------------|-----------------|----------------------------------------------------------------------|---------------|------------------|----------|---------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| `X-Mc-Idempotency-Key` | Is used to enable request idempotency | ASPSP           | Should be used to ensure that requests are not rejected as duplicate | O             | 0..1             | String   | Required to enable idempotency for the request. If not provided, unique value will be generated and sent to the bank. Example: c0ba8bf3-ef1a-419f-87a3-28a1b2e6da96 |

#### Request body {#request-body}

|      **Name**      |                                                                                  **Purpose**                                                                                   | **Required by** |                                                                                                **How it can be used**                                                                                                | **Condition** | **Multiplicity** | **Type** |                                               **Description**                                               |      **Limitations/Parameters**      |
|--------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|-----------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|---------------|------------------|----------|-------------------------------------------------------------------------------------------------------------|--------------------------------------|
| `requestInfo`      | Includes information about request being processed                                                                                                                             | MC              | This element encapsulates all request information sent to the API Service                                                                                                                                            | M             | 1..1             | Object   | Set of elements used to define the request details                                                          | -                                    |
| `xRequestId`       | ID of the request, unique to the call, as determined by the TPP                                                                                                                | TPP             | A memorable ID could be used to support in a dispute                                                                                                                                                                 | M             | 1..1             | UUID     | Free field that allows for the addition of information that can be referenced for future use                | 36                                   |
| `consentId`        | A unique reference to the account information consent stored by the ASPSP.                                                                                                     | ASPSP           | Pass this value as part of the variable recurrent payment initiation request                                                                                                                                         | M             | 1..1             | String   | The consent data received after PSU has authorized the consent                                              | 1-256                                |
| `aspspId`          | ID of a financial institution servicing the Accounts of the PSU                                                                                                                | ASPSP           | Identification of ASPSP.                                                                                                                                                                                             | M             | 1..1             | String   | This element is used to specify the identification code of a financial institution which holds PSU accounts | 36                                   |
| `isLivePsuRequest` | Indicates if PSU actively initiated request                                                                                                                                    | ASPSP           | Type of PSU request                                                                                                                                                                                                  | O             | 0..1             | Boolean  | PSU request type                                                                                            | Boolean: true, false                 |
| `psuIPAddress`     | The forwarded IP address field consists of the corresponding HTTP request IP address field between PSU and TPP.                                                                | ASPSP           | It shall be contained only if the PSU actively initiated this request                                                                                                                                                | C             | 0..1             | String   | IP address of PSU's terminal device                                                                         | Required when isLivePsuRequest=true. |
| `psuAgent`         | Indicates the user-agent for the PSU. If the PSU is using the TPP's mobile app, make sure the mobile app user-agent string is different than browser-based user-agent strings. | ASPSP           | If user-agent is supplied to ASPSP, then this information can be used by ASPSP's security mechanisms. To avoid rejections, it is recommended to include this field when providing isLivePsuRequest and psuIPAddress. | O             | 0..1             | String   | PSU's browser agent details                                                                                 | 1-256                                |
| `merchant`         | Collect merchant data for reporting purposes                                                                                                                                   | MC              | Merchant data used for reporting or reconciliation purposes                                                                                                                                                          | O             | 0..1             | Object   | Set of elements used to define the merchant details                                                         | N/A                                  |
| `id`               | Merchant identification code to identify the merchant                                                                                                                          | MC              | Unique Merchant identifier per TPP, which could be used for reporting/reconciliation purposes                                                                                                                        | M             | 1..1             | String   | Unique Merchant identifier per TPP                                                                          | 1-256                                |
| `name`             | Merchant name to identify the merchant                                                                                                                                         | MC              | Name of merchant                                                                                                                                                                                                     | M             | 1..1             | String   | Merchant name                                                                                               | 1-256                                |
| `vrpId`            | Unique identification to uniquely identify the payment resource                                                                                                                | TPP             | This value should be used to make subsequent payment specific requests                                                                                                                                               | M             | 1.1              | String   | VRP id as returned in response of VRP initiation request                                                    | 1-256                                |

Tip: For an explanation of notations used, refer to **Open Banking General FAQ** in our [Frequently Asked Questions](https://developer.mastercard.com/open-banking-connect/documentation/frequently-asked-questions/index.md) section.

### Response -- Success {#response--success}

HTTP Response Code = 200, OK
Tip: For a list of general response codes and error code structure see [Response and Error Codes](https://developer.mastercard.com/open-banking-connect/documentation/response-and-error-codes/index.md).

#### Response header {#response-header}

N/A

#### Response body {#response-body}

|             **Name**             |                                                                                                              **Purpose**                                                                                                              | **Required by** |                                                                            **How it can be used**                                                                             | **Condition** | **Multiplicity** |                                             **Type**                                              |                                                                                             **Description**                                                                                             | **Limitations/Parameters** |
|----------------------------------|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|-----------------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|---------------|------------------|---------------------------------------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|----------------------------|
| `originalRequestInfo`            | Returns original request information to the TPP                                                                                                                                                                                       | MC              | This object contains original request information                                                                                                                             | M             | 1..1             | Object                                                                                            | Original request data                                                                                                                                                                                   | N/A                        |
| `xRequestId`                     | A memorable ID which could be used to support in a dispute                                                                                                                                                                            | TPP             | This element could be used for request-response tracking                                                                                                                      | M             | 1..1             | UUID                                                                                              | Reply back with xRequestId from the original TPP request                                                                                                                                                | 36                         |
| `Payment`                        | The object contains the list of fields used to send a payment instruction to financial institution                                                                                                                                    | MC              | This element encapsulates all payment fields                                                                                                                                  | M             | 1..1             | Object                                                                                            | Set of elements used to define VRP payment details                                                                                                                                                      |                            |
| `creditorAccount`                | Unambiguous identification of the account of the creditor to which a credit entry will be posted as a result of the payment transaction.                                                                                              | ASPSP           | Specify account in a financial institution servicing the creditor                                                                                                             | M             | 1..1             | Object                                                                                            | Set of elements used to define the creditor account details                                                                                                                                             |                            |
| `schemeName`                     | Name of the identification scheme, in a coded form as published in an external list.                                                                                                                                                  | ASPSP           | This field is used to identify the type of Identification used to identify an account.                                                                                        | M             | 1..1             | Enum: `['UK.AccountNumber]`                                                                       | Account scheme name                                                                                                                                                                                     | 1-256                      |
| `identification`                 | Identification assigned by an institution to identify an account. This identification is known by the account owner.                                                                                                                  | ASPSP           | This element is used to specify the account identification number                                                                                                             | M             | 1..1             | String                                                                                            | Account identification which can be used on payload-level to address specific accounts                                                                                                                  | 1-256                      |
| `creditorName`                   | Name by which a party is known, and which is usually used to identify that party                                                                                                                                                      | ASPSP           | This element is used to specify creditor name                                                                                                                                 | O             | 0..1             | String                                                                                            | Name of the Beneficiary/Creditor                                                                                                                                                                        | 1-70                       |
| `creditorAgent`                  | Unambiguous identification of the financial institution of the creditor to which a credit entry will be posted as a result of the payment transaction                                                                                 | ASPSP           | Specify financial institution servicing an account for the creditor                                                                                                           | M             | 1..1             | Object                                                                                            | Set of elements used to define the creditor agent details                                                                                                                                               | N/A                        |
| `clearingSystemIdentification`   | Name of the identification scheme, in a coded form as published in an external list                                                                                                                                                   | ASPSP           | This field is used to identify the type of identification used to identify an agent                                                                                           | M             | 1..1             | Enum: \['UK.SortCode'\]                                                                           | Clearing system identification scheme                                                                                                                                                                   | 1-256                      |
| `memberIdentification`           | Code allocated to a financial institution by the ISO 9362 Registration Authority to identify the financial institution                                                                                                                | ASPSP           | This element is used to specify the financial institution identification code                                                                                                 | M             | 1..1             | String                                                                                            | Identification code to identify the financial institution                                                                                                                                               | 1-256                      |
| `instructedAmount`               | Amount of money to be moved between the debtor and creditor, before deduction of charges, expressed in the currency as ordered by the TPP                                                                                             | ASPSP           | This amount has to be transported unchanged through the transaction chain                                                                                                     | M             | 1..1             | Object                                                                                            | Structure aiming to embed amount and currency of current VRP payment                                                                                                                                    |                            |
| `currency`                       | A code allocated to a currency by a Maintenance Agency under an international identification scheme, as described in the latest edition of the international standard ISO 4217 "Codes for the representation of currencies and funds" | ASPSP           | The currency of the amount used in transaction                                                                                                                                | M             | 1..1             | Enum: `["GBP"]`                                                                                   | Specifies the currency of the included amount                                                                                                                                                           | pattern: `^[A-Z]{3}$`      |
| `amount`                         | A number of monetary units specified in an active currency where the unit of currency is explicit and compliant with ISO 4217.                                                                                                        | ASPSP           | This element is used to specify the amount of money to be processed                                                                                                           | M             | 1..1             | Decimal                                                                                           | Amount of money that needs to be moved between the debtor and creditor accounts                                                                                                                         | Min:0                      |
| `endToEndIdentification`         | Unique identification assigned by the TPP to unambiguously identify the transaction. This identification is passed on, unchanged, throughout the entire end-to-end chain.                                                             | ASPSP           | The end-to-end identification can be used for reconciliation or to link tasks relating to the transaction. It can be included in several messages related to the transaction. | O             | 0..1             | String                                                                                            | Field is available for TPPs to enable end-to-end identification of the transaction                                                                                                                      | 1-18                       |
| `remittanceInformationReference` | Reference information provided by the creditor to allow the identification of the underlying documents                                                                                                                                | ASPSP           | If available, the TPP should provide this reference in the structured remittance information, to enable reconciliation by the creditor upon receipt of the amount of money.   | O             | 0..1             | String                                                                                            | Unique reference, as assigned by the creditor, to unambiguously refer to the payment transaction.                                                                                                       | 1-256                      |
| `vrpId`                          | Unique identification to uniquely identify the payment resource                                                                                                                                                                       | TPP             | This value should be used to make subsequent payment specific requests                                                                                                        | O             | 0..1             | String                                                                                            | VRP id as returned in response                                                                                                                                                                          | 1-256                      |
| `transactionStatus`              | Specifies the status of the payment information group                                                                                                                                                                                 | TPP             | Transaction Status of the payment resource                                                                                                                                    | O             | 0..1             | String Examples: ISO20022 status, e.g. ACCP, ACSC, ACSP, ACTC, ACWC, ACWP, PDNG, RCVD, RJCT, CANC | Payment status as returned from the ASPSP and translated to a                                                                                                                                           | 1-256                      |
| `originalvrpId`                  | VRP id returned by the ASPSP                                                                                                                                                                                                          | TPP             | Can be used for tracking the VRP to the ASPSP                                                                                                                                 | O             | 0..1             | String                                                                                            | VRP id as returned by the ASPSP                                                                                                                                                                         | 1-256                      |
| `refundAccount`                  | refundAccount object is available in the response only when PSU has provided consent to share account details with the TPP. It includes PSU's account details.                                                                        | TPP             | This element encapsulates refund account details                                                                                                                              | O             | 0..1             | Object                                                                                            | refundAccount object is available in the response only when PSU has provided consent to share account details with the TPP. It includes PSU's account details.                                          |                            |
| `schemeName`                     | Name of the scheme, used to specify the account identification type.                                                                                                                                                                  | TPP             | This field is used to specify the account identification type                                                                                                                 | O             | 0..1             | String                                                                                            | Name of the scheme, used to specify the account identification type. Example values: 'UK.AccountNumber'                                                                                                 | 1-256                      |
| `identification`                 | Account identification number. It can be used on payload-level to mention specific account.                                                                                                                                           | TPP             | Details received in this field can be used for creditor account details in the reversed payment                                                                               | O             | 0..1             | String                                                                                            | Account identification number.                                                                                                                                                                          | 1-256                      |
| `name`                           | This field is used to send the name of debtor account owner.                                                                                                                                                                          | TPP             | The data from this field should be used in the `creditorName` field for refund payments.                                                                                      | O             | 0..1             | String                                                                                            | The account name is the name or names of the account owner(s) represented at an account level as it was assigned by the ASPSP.                                                                          | 1-256                      |
| `refundAgent`                    | refundAgent object is available in the response only when PSU has provided consent to share account details with the TPP. It includes details of the financial institution servicing the refund account.                              | TPP             | This element encapsulates refund agent details                                                                                                                                | O             | 0..1             | Object                                                                                            | refundAgent object is available in the response only when PSU has provided consent to share account details with the TPP. It includes details of the financial institution servicing the refund account |                            |
| `clearingSystemIdentification`   | Denomination of the system, used to specify agent identification type.                                                                                                                                                                | TPP             | This field is used to specify the type of agent identification.                                                                                                               | O             | 0..1             | String                                                                                            | Denomination of the system, used to specify agent identification type. Example: 'UK.SortCode'                                                                                                           | 1-256                      |
| `memberIdentification`           | Identification code of the financial institution as assigned by the ISO 9362 Registration Authority.                                                                                                                                  | TPP             | This element is used to specify the financial institution identification code.                                                                                                | O             | 0..1             | String                                                                                            | Identification code to identify the financial institution.                                                                                                                                              | 1-256                      |
| `requestedExecutionDate`         | VRP payment execution date                                                                                                                                                                                                            | TPP             | The date on which VRP was executed.                                                                                                                                           | O             | 0..1             | String IsoDateTime                                                                                | VRP execution date                                                                                                                                                                                      |                            |
| `originalPaymentStatuse`         | Specifies the status of the payment information group. Value returned by ASPSP.                                                                                                                                                       | TPP             | Could be used to support in a dispute                                                                                                                                         | O             | 0..1             | String                                                                                            | Status of the payment returned by ASPSP                                                                                                                                                                 | 1-256                      |

## Feature specific error codes {#feature-specific-error-codes}

Tip: For a list of general response codes and error code structure see [Response and Error Codes](https://developer.mastercard.com/open-banking-connect/documentation/response-and-error-codes/index.md).

|                                **Message**                                | **Reason Code** |                            **Description**                            |                               **Developer Details**                                |                                                  **Typical Occurrences**                                                  |                                    **Next Steps**                                    |
|---------------------------------------------------------------------------|-----------------|-----------------------------------------------------------------------|------------------------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------------------|--------------------------------------------------------------------------------------|
| "Conditional field psuIPAddress is expected when isLivePsuRequest='true'" | `FORMAT_ERROR`  | "IP address" field is mandatory if parameter "isLivePsuRequest"=true. | "path\[i\]=;" where i = 0, 1, 2, etc. for each element that failed the validation. | Typically occurs because the TPP has provided in request "isLivePsuRequest"=true and didn't provide the IP address value. | Include the IP address of PSU in the request when providing "isLivePsuRequest"=true. |

**Error example code**

```json
{  "Errors": {
    "Error": [
      {
        "Source": "OBC",
        "ReasonCode": "FORMAT_ERROR",
        "Description": "Conditional field psuIPAddress is expected when isLivePsuRequest='true",
        "Details": "path[0]=/requestInfo/psuIPAddress"
 }
    ]
  }
}
```

